#Include Once "win\gdiplus.bi"
Using GDIPLUS

Extern "Windows-MS"

Sub Boost(ByVal hCanvas as GpGraphics Ptr, ByVal tData As Any Ptr, _
			 iCountX As UInteger, iCountY As UInteger, _
			 fX As Single, fY As Single, fZ As Single, fW As Single, fH As Single, fScale As Single = 1.0, fZDeepCorrection As Single = 1000.0) Export
			 
	Dim As UInteger c, iUBound, iSingle
	Dim As Single Ptr pX, pY, pZ, pfX, pfY, pFZ
	Dim As UInteger Ptr pPen
	
	Dim As Single fCosRotX, fSinRotX, fCosRotY, fSinRotY, fCosRotZ, fSinRotZ, f1, f2, f3, f4, f5, f6, fXPos, fYPos, fZPos, fZPerspCorrection
	
	iUBound = iCountX * iCountY + iCountX + iCountY + 1
	iSingle = SizeOf(Single)
	
	For c = 0 To iUbound - 1
			
			'get pointers to each struct element
			pX = tData '+ 0 * iUBound + 0 * iSingle
			pY = tData + 1 * iUBound * iSingle
			pZ = tData + 2 * iUBound * iSingle
			pfX = tData + 3 * iUBound * iSingle
			pfY = tData + 4 * iUBound * iSingle
			pfZ = tData + 5 * iUBound * iSingle
			pPen = tData + 6 * iUBound * iSingle
			
			
			'calculate 3D rotation
			fCosRotX = Cos(fX)
			fSinRotX = Sin(fX)
			fCosRotY = Cos(fY)
			fSinRotY = Sin(fY)
			fCosRotZ = Cos(fZ)
			fSinRotZ = Sin(fZ)
		
			f1 = fCosRotY * pX[c]
			f2 = fSinRotX * pY[c]
			f3 = fCosRotX * pZ[c]
			f4 = fCosRotX * pY[c]
			f5 = fSinRotX * pZ[c]
			f6 = f1 - fSinRotY * (f2 + f3)
			fXPos = (fCosRotZ * f6 - fSinRotZ * (f4 - f5)) * fScale
			fYPos = (fSinRotZ * f6 + fCosRotZ * (f4 - f5)) * fScale
			fZPos = (fSinRotY * pX[c] + fCosRotY * (f2 + f3)) * fScale
			fZPerspCorrection = 1 / (fZPos / fZDeepCorrection + 1)
			pfX[c] = fXPos * fZPerspCorrection + fW
			pfY[c] = fYPos * fZPerspCorrection + fH
			pfZ[c] = fZPos
			
			
			'draw lines
			If c > 0 Then
				GdipDrawLine(hCanvas, pPen[c], pfX[c - 1], pfY[c - 1], pfX[c], pfY[c])
			EndIf

	Next

End Sub

End Extern